/**
 * filename:index.js
 * desc:main js in demo template
 * deps:jQuery
 * authors:zc
 * time:2014-11-04 14:33:19
 * version:0.0.1
 * updatelog:
 * 0.0.1:the first version
 *
 **/
(function(ns) {
    var _earth = null,
        _dataProcess = null,
        _serverProtocol = 'http://',
        _serverIp = '192.168.1.228',
        _dataConfigIndex = 0,
        _sysHelper = null,
        _position = [117.17483254964169, 34.26213681442609, 0, 20.689436806126547, 58.271531307042515, 0, 931.0679512414465];

    $(function() {
        _resize();
        //窗口大小改变时重新计算页面布局
        $(window).resize(function() {
            _resize();
        });

        ns.document.oncontextmenu = function() {
            return false;
        }

        // _createEarth($('.cs-panel-right'));
        _createEarth($('#earthContainer'));

        ns.STAMP.oper.showPanel('layerPanel');

        $('#btnContainer>button[tag="menu"]').click(function() {
            ns.STAMP.oper.showPanel($(this).attr('data'))
;

            $('#btnContainer>button[tag="menu"]').each(function(i,n){
                this.blur();
                $(this).removeAttr('type');
            });
        });
    });

    /**
     * 将指定对象的目标样式转换为数值型，用于计算对象目标样式的宽或高
     * @param  {jquery对象} el        对象
     * @param  {string}     style   指定对象的目标样式
     * @return {float}              样式转换为数值的结果，若不能转换则返回0
     */
    function _css2num(el, style) {
        var n = parseFloat(el.css(style));
        if (isNaN(n)) {
            return 0;
        }

        return n;
    }

    /**
     * 计算目标对象所占用空间的宽度
     * @param  {jquery对象} el    目标对象
     * @return {float}          宽度
     */
    function _calcWidth(el) {
        var w = _css2num(el, 'width');
        w += _css2num(el, 'margin-left');
        w += _css2num(el, 'margin-right');
        w += _css2num(el, 'border-left-width');
        w += _css2num(el, 'border-right-width');
        w += _css2num(el, 'padding-left');
        w += _css2num(el, 'padding-right');
        return w;
    }

    /**
     * 计算目标对象所占用空间的高度
     * @param  {jquery对象} el    目标对象
     * @return {float}          高度
     */
    function _calcHeight(el) {
        var h = _css2num(el, 'height');
        h += _css2num(el, 'margin-top');
        h += _css2num(el, 'margin-bottom');
        h += _css2num(el, 'padding-top');
        h += _css2num(el, 'padding-bottom');
        h += _css2num(el, 'border-top-width');
        h += _css2num(el, 'border-bottom-width');
        return h;
    }

    /**
     * 计算页面布局
     * @return {[type]} [description]
     */
    function _resize() {
        var mc = $('.cs-mainContainer');
        var tp = $('.cs-panel-top');
        var lp = $('.cs-panel-left');
        var rp = $('.cs-panel-right');

        var mcw = _css2num(mc, 'width');
        var mch = _css2num(mc, 'height');
        var tph = _calcHeight(tp);
        var lpw = _calcWidth(lp);
        lp.css('height', (mch - tph) + 'px');
        rp.css('height', (mch - tph) + 'px');
        rp.css('width', (mcw - lpw) + 'px');

        $('.cs-panel-left>div').each(function() {
            $(this).css('height', (mch - tph - 20) + 'px');
        });
    }

    function _unload() {
        //destroy app if needed
        if(typeof ns.STAMP.initer.destroyPano == 'function'){
            ns.STAMP.initer.destroyPano();
        }
        
        seearth.Suicide();
    }

    /**
     * 创建地球
     * @param  {DOM对象} container 地球的容器
     * @return {void}
     */
    function _createEarth(container) {
        $(container).html('<object id="seearth" ' +
            'classid="clsid:EA3EA17C-5724-4104-94D8-4EECBD352964" ' +
            'data="data:application/x-oleobject;base64,Xy0TLBTXH0q8GKFyFzl3vgAIAADYEwAA2BMAAA==" ' +
            'width="100%" height="100%"></object>' +
            '<object id="dataProcess" classid="clsid:DDA7E893-8EEE-4A1E-A506-867932BD0FB9" style="display:none;"></object>');
        seearth.Event.OnCreateEarth = function() {
            seearth.Event.OnCreateEarth = function() {};

            //页面卸载时销毁地球
            $(window).unload(function() {
                _unload();
            });

            _earth = seearth;
            _dataProcess = dataProcess;
            _sysHelper = new STAMP.SeSysInfoHelper({
                earth: _earth
            });

            $.extend(ns.STAMP, {
                earth: _earth,
                dataProcess: _dataProcess,
                sysHelper: _sysHelper
            });

            var sysInfo = _sysHelper.loadSysConfig({
                cache: false
            });
            if(sysInfo.Position != ''){
                _position = sysInfo.Position.split(',');
            }

            seearth.Event.OnDocumentChanged = function(type, guid) {
                seearth.Event.OnDocumentChanged = function() {};

                if (type == 1) {
                    // seearth.Environment.SetDatabaseLink(_serverProtocol + _serverIp);
                    seearth.GlobeObserver.GotoLookat(_position[0], _position[1], _position[2],
                        _position[3], _position[4], _position[5], _position[6]);

                    _initLayerTree();
                }
            };
            seearth.Load(_serverProtocol + _serverIp, _dataConfigIndex);
        }
    }

    function _initLayerTree() {
        var seLayerManager = new STAMP.SeLayerManager({
            earth: seearth
        });
        seLayerManager.show2DMap({
            visible: false
        });
        var layerData = seLayerManager.getLayerTreeData();
        var treeSetting = {
            showLine: true,
            checkable: true,
            check: {
                enable: true
            },
            callback: {
                onDblClick: function(event, treeId, treeNode) {
                    seLayerManager.zoomToLayerByGuid(treeNode.id);
                },
                onCheck: function(event, treeId, treeNode) {
                    if (treeNode.checked) {
                        seLayerManager.showLayer(treeNode.id);
                    } else {
                        seLayerManager.hideLayer(treeNode.id);
                    }
                }
            },
            view: {
                dblClickExpand: false
            }
        };
        $.fn.zTree.init($('#layerTree'), treeSetting, layerData);

        //init app
        if (!ns.STAMP.initer) {
            ns.STAMP.initer = {};
        }
        if (typeof ns.STAMP.initer.initPano == 'function') {
            ns.STAMP.initer.initPano(seearth, dataProcess);
        }
    }

    if (ns.STAMP == undefined) {
        ns.STAMP = {};
    }
    if (ns.STAMP.oper == undefined) {
        ns.STAMP.oper = {};
    }

    $.extend(ns.STAMP.oper, {
        showPanel: function(panelId) {
            $('.cs-panel-left>div').each(function(i, n) {
                if (this.id == panelId) {
                    $(this).show();
                } else {
                    $(this).hide();
                }
            });
        }
    });
})(window)
