(function(ns) {
    var _earth = null,
        _dataProcess = null,
        _data = {},

        BAIDU_MAP_AK = '7f99fb35f97dfa1d9506bbf24bcad3eb',
        BAIDU_MAP_API_URL = 'http://api.map.baidu.com/api',
        BAIDU_MAP_API_VERSION = '2.0',

        INIT_LNGLAT_LIST = [{
            //徐州国税局
            lng: 117.172598,//117.172653,
            lat: 34.258146,//34.258069,
            heading: 0,
        }, {
            //徐师一附小
            lng: 117.179480,//117.179433,
            lat: 34.258619,//34.258686,
            heading: 90
        }],

        OFFSET_LNG = 0.00073,
        OFFSET_LAT = 0.00024,


        _curLng = INIT_LNGLAT_LIST[1].lng,
        _curLat = INIT_LNGLAT_LIST[1].lat,
        _curAlt = 31,
        _curHeading = INIT_LNGLAT_LIST[1].heading,
        _curTilt = 6,
        _curRoll = 0,
        _curRange = 4,

        _bmap = null,
        _bpano = null,
        _bpanoSvc = null,
        _bmarker = null;


    //main
    function _initPano(earth, dataProcess) {
        _earth = earth;
        _dataProcess = dataProcess

        _earth.GlobeObserver.EnablePan = false;
        _earth.GlobeObserver.EnableRotate = false;
        _earth.GlobeObserver.EnableZoom = false;

        _initEarth();
        _loadBMapApi();

        _initUI();
        _addEventListeners();
    }

    function _destroyPano() {
        _removeEventListeners();
    }

    function _initUI() {

    }

    function _addEventListeners() {

    }

    function _removeEventListeners() {

    }

    function _attr(o, k, v) {
        try {
            var ks = k.split('.');
            if (!o) {
                o = {};
            }
            var ot = o;
            var i = 0;
            for (i = 0; i < ks.length - 1; i++) {
                if (!ot[ks[i]]) {
                    ot[ks[i]] = {};
                }
                ot = ot[ks[i]];
            }
            if (typeof v != 'undefined') {
                ot[ks[i]] = v;
            }
            return ot[ks[i]];
        } catch (e) {

        }

        return undefined;
    }

    function _valueOrDefault(obj, property, defaultValue) {
        try {
            if (!obj) {
                return defaultValue;
            }
            var val = _attr(obj, property);
            if (typeof val == 'undefined') {
                return defaultValue;
            }
            return val;
        } catch (e) {
            return defaultValue;
        }
    }

    function _initEarth() {
        _updateEarth();
        _earth.Event.OnDocumentUpdate = function() {
            var curPose = _earth.GlobeObserver.Pose;
            _curLng = curPose.Longitude;
            _curLat = curPose.Latitude;
            _curAlt = curPose.Altitude;
            _curHeading = curPose.Heading;
            _curTilt = curPose.Tilt;
            _curRoll = curPose.Roll;
            _curRange = curPose.Range;

            // if (_bpano) {
            //     var pos = _getPose({
            //         lng: _curLng,
            //         lat: _curLat,
            //         tilt: -_curTilt,
            //         type: 1
            //     })
            //     _showPano(pos);
            // }
        };
    }

    function _loadBMapApi() {
        var script = document.createElement("script");
        script.type = "text/javascript";
        script.src = BAIDU_MAP_API_URL + '?v=' + BAIDU_MAP_API_VERSION +
            '&callback=STAMP.initBMaps&ak=' + BAIDU_MAP_AK;
        document.body.appendChild(script);
    }

    function _initBMaps() {
        _initBMap('bmap');
        _initBPanorama('bpanorama');
    }

    function _initBMap(container) {
        var options = {
            mapType: BMAP_NORMAL_MAP,
            maxZoom: 18,
            drawMargin: 0,
            enableFulltimeSpotClick: true,
            enableHighResolution: true
        };
        _bmap = new BMap.Map(container, options);
        _bmap.enableScrollWheelZoom();
        _bmap.addTileLayer(new BMap.PanoramaCoverageLayer());

        var pose = _getPose({
            type: 1
        });
        var cp = new BMap.Point(pose.lng, pose.lat);
        _bmap.centerAndZoom(cp, 18);

        _bmarker = new BMap.Marker(cp);
        _bmarker.enableDragging();
        _bmap.addOverlay(_bmarker);
        _bmarker.addEventListener('dragend', function(e) {
            if (_bpano) {
                /*
                _bpano.setPosition(e.point);
                _bpano.setPov({
                    heading: _curHeading,
                    pitch: _curTilt
                });
                */
                _showPano({
                    lng: e.point.lng,
                    lat: e.point.lat,
                    tilt: -_curTilt
                });
            }
        });
    }

    function _initBPanorama(container) {
        _bpano = new BMap.Panorama(container);

        var pose = _getPose({
            type: 1
        });
        var cp = new BMap.Point(pose.lng, pose.lat);

        /*
        _bpano.setPosition(cp);
        _bpano.setPov({
            heading: pose.heading,
            pitch: pose.tilt
        });
        */
        _showPano(pose);
        _bpano.setZoom(3);
        _bpano.addEventListener('position_changed', function(e) {
            var pos = _bpano.getPosition();
            var pov = _bpano.getPov();
            if (_bmap) {
                _bmap.setCenter(new BMap.Point(pos.lng, pos.lat));
                _bmarker.setPosition(pos);
            }

            _updateEarth({
                lng: pos.lng,
                lat: pos.lat,
                heading: pov.heading,
                tilt: -pov.pitch,
                range: 0,
                type: 2
            });
        });

        _bpano.addEventListener('pov_changed', function(e) {
            var pos = _bpano.getPosition();
            var pov = _bpano.getPov();
            _updateEarth({
                lng: pos.lng,
                lat: pos.lat,
                heading: pov.heading,
                tilt: -pov.pitch,
                range: 0,
                type: 2
            });
        });
    }

    function _showPano(options) {
        // if (!_bpanoSvc) {
        //     _bpanoSvc = new BMap.PanoramaService();
        // }
        var lng = _valueOrDefault(options, 'lng', _curLng);
        var lat = _valueOrDefault(options, 'lat', _curLat);
        var heading = _valueOrDefault(options, 'heading', _curHeading);
        var tilt = _valueOrDefault(options, 'tilt', _curTilt);
        var cp = new BMap.Point(lng, lat);
        _bpano.setPosition(cp);
        _bpano.setPov({
            heading: heading,
            pitch: tilt
        });
        // _bpanoSvc.getPanoramaByLocation(cp, 50, function(data) {
        //     if (data) {
        //         var cp2 = data.position;
        //         _bpano.setPosition(cp2);
        //         _bpano.setPov({
        //             heading: heading,
        //             pitch: tilt
        //         });
        //     }
        // });
    }

    function _getPose(options) {
        var op = {
            lng: _valueOrDefault(options, 'lng', _curLng),
            lat: _valueOrDefault(options, 'lat', _curLat),
            alt: _valueOrDefault(options, 'alt', _curAlt),
            heading: _valueOrDefault(options, 'heading', _curHeading),
            tilt: _valueOrDefault(options, 'tilt', _curTilt),
            roll: _valueOrDefault(options, 'roll', 0),
            range: _valueOrDefault(options, 'range', _curRange)
        };
        var t = _valueOrDefault(options, 'type', 0);
        var p = op;
        switch (t) {
            case 1:
                //wgs84 to bd09
                p.lng += OFFSET_LNG;
                p.lat += OFFSET_LAT;
                p = coorTran.gcj02_2_bd09(coorTran.wgs84_2_gcj02(p));
                break;
            case 2:
                //bd09 to wgs84
                p = coorTran.gcj02_2_wgs84(coorTran.bd09_2_gcj02(p));
                p.lng -= OFFSET_LNG;
                p.lat -= OFFSET_LAT;
                break;
            default:
                break;
        }
        return p;
    }

    function _updateEarth(options) {
        var pose = _getPose(options);
        pose.alt = _earth.Measure.MeasureTerrainAltitude(pose.lng, pose.lat) + 2;
        // _earth.GlobeObserver.GotoLookat(pose.lng, pose.lat, pose.alt, pose.heading, pose.tilt, pose.roll, pose.range);
        _earth.GlobeObserver.FixedPointObserve(pose.lng, pose.lat, pose.alt, pose.heading, pose.tilt, pose.roll);
        _earth.GlobeObserver.StopFixedPointObserve();
    }



    var coorTran = {
        a: 6378245,
        ee: 0.00669342162296594323,
        x_pi: Math.PI * 3000 / 180,

        wgs84_2_gcj02: function(options) {
            var op = {};
            $.extend(op, options);
            if (this.outOfChina(op.lng, op.lat)) {
                return op;
            }

            var dLon = this._transformLon(op.lng - 105, op.lat - 35);
            var dLat = this._transformLat(op.lng - 105, op.lat - 35);

            var radLat = op.lat / 180 * Math.PI;
            var magic = Math.sin(radLat);
            magic = 1 - this.ee * magic * magic;
            var sqrtMagic = Math.sqrt(magic);

            dLon = (dLon * 180) / (this.a / sqrtMagic * Math.cos(radLat) * Math.PI);
            dLat = (dLat * 180) / ((this.a * (1 - this.ee)) / (magic * sqrtMagic) * Math.PI);

            op.lng += dLon;
            op.lat += dLat;

            return op;
        },
        gcj02_2_wgs84: function(options) {
            var op = {};
            $.extend(op, options);

            var o = null,
                lng = 0,
                lat = 0;
            while (true) {
                o = this.wgs84_2_gcj02(op);
                lng = options.lng - o.lng;
                lat = options.lat - o.lat;

                if (Math.abs(lng) < 1e-7 && Math.abs(lat) < 1e-7) {
                    return op;
                }

                op.lng += lng;
                op.lat += lat;
            }
        },
        gcj02_2_bd09: function(options) {
            var op = {};
            $.extend(op, options);

            var x = op.lng,
                y = op.lat;
            var z = Math.sqrt(x * x + y * y) + 0.00002 * Math.sin(y * this.x_pi);
            var theta = Math.atan2(y, x) + 0.000003 * Math.cos(x * this.x_pi);
            op.lng = z * Math.cos(theta) + 0.0065;
            op.lat = z * Math.sin(theta) + 0.006;

            return op;
        },
        bd09_2_gcj02: function(options) {
            var op = {};
            $.extend(op, options);

            var x = op.lng - 0.0065,
                y = op.lat - 0.006;
            var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * this.x_pi);
            var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * this.x_pi);
            op.lng = z * Math.cos(theta);
            op.lat = z * Math.sin(theta);

            return op;
        },

        _transformLon: function(x, y) {
            var r = 300 + x + 2 * y + 0.1 * x * x + 0.1 * x * y + 0.1 * Math.sqrt(x > 0 ? x : -x);
            r += (20 * Math.sin(6 * x * Math.PI) + 20 * Math.sin(2 * x * Math.PI)) * 2 / 3;
            r += (20 * Math.sin(x * Math.PI) + 40 * Math.sin(x / 3 * Math.PI)) * 2 / 3;
            r += (150 * Math.sin(x / 12 * Math.PI) + 300 * Math.sin(x / 30 * Math.PI)) * 2 / 3;
            return r;
        },
        _transformLat: function(x, y) {
            var r = -100 + 2 * x + 3 * y + 0.2 * y * y + 0.1 * x * y + 0.2 * Math.sqrt(x > 0 ? x : -x);
            r += (20 * Math.sin(6 * x * Math.PI) + 20 * Math.sin(2 * x * Math.PI)) * 2 / 3;
            r += (20 * Math.sin(y * Math.PI) + 40 * Math.sin(y / 3 * Math.PI)) * 2 / 3;
            r += (160 * Math.sin(y / 12 * Math.PI) + 320 * Math.sin(y * Math.PI / 30)) * 2 / 3;
            return r;
        },
        outOfChina: function(lng, lat) {
            if (lng < 72.004 || lng > 137.8347) {
                return true;
            }
            if (lat < 0.8293 || lat > 55.8271) {
                return true;
            }
            return false;
        }
    };


    if (!ns.STAMP.initer) {
        ns.STAMP.initer = {};
    }
    ns.STAMP.initer.initPano = _initPano;
    ns.STAMP.initer.destroyPano = _destroyPano;
    ns.STAMP.initBMaps = _initBMaps;
})(window);
